
def AddPotential(pf_in, pf_out,GravFieldType=22,debug=0):
    """Adds the necessary field and meta data to a simulation in order to restart with WritePotential=1
    *in_prefix* is the parameter file that does not have WritePotential on.
    *out_prefix* is the new parameter file to be created, with WritePotential  on.
    A completely new dataset is written (in principle),
    *GravFieldType* is the enzo field type for the potential field.  In 1.5, this is 22. 
    In Enzo2.0, this is 30.
    Note that for Enzo2.0, the MetaData group is not properly copied.
    
    This is a draft version, and is guaranteed to not work.
    
    """
    TopGridDimensions = None
    #hierarchy file relatively unchanged, only field types
    in_hierarchy = open(pf_in+'.hierarchy','r')
    ou_hierarchy = open(pf_out+'.hierarchy','w')
    for in_line in in_hierarchy:
        try:
            in_line.index('=')
        except:
            ou_hierarchy.write(in_line)
            continue
        variable_set = in_line.split('=')
        variable = variable_set[0].split(' ')[0]
        value = variable_set[1][:-1]
        if variable == 'NumberOfBaryonFields':
            NBF = int(value)
            ou_hierarchy.write('NumberOfBaryonFields = %d\n'%(NBF + 1))
        elif variable == 'FieldType':
            ou_hierarchy.write(variable + "=" + value + " %d\n"%(GravFieldType))
        else:
            ou_hierarchy.write(in_line)
    in_hierarchy.close()
    ou_hierarchy.close()

    #Parameter file
    in_param = open(pf_in,'r')
    ou_param = open(pf_out,'w')
    for in_line in in_param:
        if in_line.startswith('TopGridDimensions'):
            TopGridDimensions = int(in_line.split(' ')[-3])
        ou_param.write(in_line)
    ou_param.write('DataLabel[%d] = GravPotential\n'%(NBF))
    ou_param.write('WritePotential = 1\n')
    ou_param.close()
    ou_param.close()
    #re-work boundary.  That's some delicious copypasta
    in_boundary = open(pf_in+'.boundary','r')
    ou_boundary = open(pf_out+'.boundary','w')
    for in_line in in_boundary:
        #!hard code: all this should be generalized into a function, it's the same as the
        #hierarchy mangling.
        try:
            in_line.index('=')
        except:
            ou_boundary.write(in_line)
            continue
        variable_set = in_line.split('=')
        variable = variable_set[0].split(' ')[0]
        value = variable_set[1][:-1]
        if variable == 'NumberOfBaryonFields':
            ou_boundary.write('NumberOfBaryonFields = %d\n'%(NBF+1)) #! hard code crap
        elif variable == 'BoundaryFieldType':
            ou_boundary.write(variable + " = " + value + " %d\n"%(GravFieldType))
        elif variable == 'BoundaryValuePresent':
            string='BoundaryValuePresent = 0 0 0 0 0 0 \n'
            ou_boundary.write(string)
        else:
            ou_boundary.write(in_line)
    
    in_boundary.close()
    ou_boundary.close()
    
    #re-work grids
    file_list =  glob.glob(pf_in+".cpu????")
    file_list.sort()
    for in_cpu_name in file_list:

        out_cpu_name = pf_out + ".cpu" + in_cpu_name.split(".cpu")[1]
        print out_cpu_name
        in_cpu = h5py.File(in_cpu_name,'r')
        out_cpu = h5py.File(out_cpu_name,'w')
        try:
            for name, in_grid in in_cpu.listitems():
                if name.startswith('Grid'):
                    out_grid=out_cpu.create_group(name)
                    for field_name in in_grid:
                        if debug > 0:
                            print in_cpu_name, field_name
                        field = in_grid[field_name]
                        #pdb.set_trace()
                        data = field[:,:,:]
                        out_grid.create_dataset(name,data.shape,data=data)
                    out_grid.create_dataset('GravPotential',data.shape,data=data*0)
        except:
            raise
        finally:
            out_cpu.close()
            in_cpu.close()


    #Write the boundary condition
    boundary_file=pf_out+'.boundary.hdf'
    outfile=h5py.File(boundary_file,'w')
    try:
        print boundary_file
        dim = TopGridDimensions+14
        print dim
        NumberOfBaryonFields = NBF + 1
        size = dim*dim*2*NumberOfBaryonFields
        for i in range(3):
            set_name = 'BoundaryDimensionType.%d'%i
            set = nar([3.0]*size,dtype='f4')
            outfile.create_dataset(set_name,(size,),data=set)
        for i in range(3):
            set_name = 'BoundaryDimensionValue.%d'%i
            set = nar([0.0]*size,dtype='f4')
            outfile.create_dataset(set_name,(size,),data=set)
    except:
        raise
    finally:
        outfile.close()
if 1:
    pf_in = '/lustre/dcwan/scratch/tg-dcoll/examples/Cosmology/Hydro/AD_pot_test/DD0001/data0001'
    pf_out = '/lustre/dcwan/scratch/tg-dcoll/examples/Cosmology/Hydro/AD_pot_test/wp0001/data0001'
    AddPotential(pf_in, pf_out,GravFieldType=22,debug=1)

